<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



$conf = array();
$actions = array();
include("/etc/lms/lms-subsys-stats-collect.conf");

if (!$config['stats_enable'])
	exit();

require("/etc/lms/main.php");

/*
define('DFTK_ROOT_PATH', "/usr/share/dftk/");
define('LMS_ROOT_PATH', "/usr/share/lms-core-api/");

require_once(LMS_ROOT_PATH."inc.php");
require_once(LMS_ROOT_PATH."hosts/inc.php");
require_once(LMS_ROOT_PATH."adsl/inc.php");

$langmgr =& new DftkDaLanguageManager();
$resultmgr =& new DftkDaTraceManager($langmgr);

$con =& new DftkLdapConnection($resultmgr);
$con->set_wrapping_parameter($config[base], "ou=Users", "ou=CommonUsers", "ou=AdminUsers", "ou=ServiceUsers");

$r =& $con->connect($config[server] , true);
if ($r->has_error())
	exit;
$r =& $con->bind($config[login], $config[passwd]);
if ($r->has_error())
	exit;

$hostmgr =& new LmsHostManager($resultmgr, $con);
$agroupmgr =& new LmsAdslGroupManager($resultmgr, $con);
*/

$macros = array();
$macros['start'] = " --start 0 --step 60 ";
$macros['rra_average'] = " RRA:AVERAGE:0.5:1:360 RRA:AVERAGE:0.5:5:2046 RRA:AVERAGE:0.5:60:912 RRA:AVERAGE:0.5:360:1584 ";
$macros['rra_max'] = " RRA:MAX:0.5:1:360 RRA:MAX:0.5:5:2046 RRA:MAX:0.5:60:912 RRA:MAX:0.5:360:1584 ";

define(DATA_DIR, "/var/lib/lms-subsys-stats-collect/");
$conf['remote_dir'] = $conf['remote_dir']."/";

$info = posix_uname();
$host = $info['nodename'];

if ($argc!=2)
{
	printf("Error : no command specified !\n");
}
else
{
	switch($argv[1])
	{
	case "create":
		create_rrd();
		break;
	case "delete":
		delete_rrd();
		break;
	case "update":
		create_rrd();
		update_rrd();
		store_rrd();
		break;
	default:
		printf("Error : bad command specified !\n");
	}
}

/*
$con->disconnect();
unset($con);
*/



function percent($val1, $val2, $tmps)
{
	return(abs($val1 - $val2) / $tmps * 100);
}


function create_rrd()
{
	//global		$conf, $actions, $macros, $host, $net_bp, $adsl, $agroupmgr, $hostmgr;
	global		$conf, $actions, $macros, $host, $net_bp, $agroupmgr, $hostmgr;

	if (!file_exists(DATA_DIR.$host))
		mkdir(DATA_DIR.$host, 0700);

	if (file_exists(DATA_DIR.$host."/params.conf"))
	{
		$fd = fopen(DATA_DIR.$host."/params.conf", "rb");
		$data = fread($fd, filesize(DATA_DIR.$host."/params.conf"));
		$params = unserialize($data);
		fclose($fd);
	}
	else
		$params = array();

	if ($actions['cpu'])
	{
		$nbproc = shell_exec("echo $(cat /proc/cpuinfo  | grep processor | wc -l)");

		for ($i=0; $i<$nbproc; $i++)
		{
			$file = DATA_DIR.$host."/cpu".$i.".rrd";
			
			if (!file_exists($file))
				shell_exec("rrdtool create ".$file.$macros['start']."DS:user:GAUGE:100:0:U DS:system:GAUGE:100:0:U DS:nice:GAUGE:100:0:U DS:idle:GAUGE:100:0:U".$macros['rra_average']);
		}
	}

	if ($actions['net'])
	{
		if (!is_array($params['net_bp']))
		{
			$params['net_bp'] = array();
			$params['net_ip'] = array();
		}

		$nbnet = shell_exec("echo $(cat /proc/net/dev | grep eth | wc -l)");
		for ($i=0; $i<$nbnet; $i++)
		{
			$type = "eth".$i;
			create_net($params, $type);
		}

		$nbnet = shell_exec("echo $(cat /proc/net/dev | grep ppp | wc -l)");
		for ($i=0; $i<$nbnet; $i++)
		{
			$type = "ppp".$i;
			create_net($params, $type);
		}
	}


	if ($actions['mem'])
	{
		$file = DATA_DIR.$host."/mem.rrd";

		if (!file_exists($file))
			shell_exec("rrdtool create ".$file.$macros['start']."DS:mtotal:GAUGE:100:U:U DS:mused:GAUGE:100:U:U DS:stotal:GAUGE:100:U:U DS:sused:GAUGE:100:U:U".$macros['rra_average']);
	}

	if ($actions['load'])
	{
		$file = DATA_DIR.$host."/load.rrd";

		if (!file_exists($file))
			shell_exec("rrdtool create ".$file.$macros['start']."DS:load:GAUGE:100:U:U".$macros['rra_average']);
	}

	if ($actions['disk'])
	{
		$file = DATA_DIR.$host."/disk.rrd";

		if (!file_exists($file))
			shell_exec("rrdtool create ".$file.$macros['start']."DS:disk:COUNTER:100:0:U".$macros['rra_max']);
	}

	/*
	if ($actions['adsl'])
	{
		$r =& $agroupmgr->get_list(array('hostname'), "(servername=".$host.")");
		if  ($r->get_result('count'))
		{
			$r =& $hostmgr->select_result(0);
			$hostlist = $r->get_result('hostname');
			$params['adsl'] = array();

			for ($i=0; count($hostlist); $i++)
			{
				$r =& $hostmgr->find($hostlist[$i]);
				if ($r->get_result('count'))
				{
					$params['adsl'][$hostlist[$i]] = array();
				}
			}
		}
	}
	*/

	$fd = fopen(DATA_DIR.$host."/params.conf", "wb");
	$data = serialize($params);
	fwrite($fd, $data);
	fclose($fd);
}

function create_net(&$params, $type)
{
	global		$conf, $macros, $host, $net_bp;

	$file = DATA_DIR.$host."/net_".$type.".rrd";

	$z = shell_exec("echo \$(/sbin/ifconfig ".$type." | grep 'inet addr' | awk '{print \$2}' | awk -F: '{print \$2}')");
	while ($z != trim($z))
		$z = trim($z);
	$params['net_ip'][$type] = $z;

	$build = false;
	if ((!file_exists($file)) && $net_bp[$type.'_in'] && $net_bp[$type.'_out'])
		$build = true;
	else
		if (($params['net_bp'][$type.'_in']!=$net_bp[$type.'_in']) || ($params['net_bp'][$type.'_out']!=$net_bp[$type.'_out']))
		{
			shell_exec("rm ".$file);
			if ($net_bp[$type.'_in'] && $net_bp[$type.'_out'])
				$build = true;
		}

	if ($build)
	{
		$params['net_bp'][$type.'_in'] = $net_bp[$type.'_in'];
		$params['net_bp'][$type.'_out'] = $net_bp[$type.'_out'];

		$lim_in =  $params['net_bp'][$type.'_in']*105/100;
		$lim_out =  $params['net_bp'][$type.'_out']*105/100;

		shell_exec("rrdtool create ".$file.$macros['start']."DS:input:COUNTER:100:0:".$lim_in." DS:output:COUNTER:100:0:".$lim_out." DS:ierror:COUNTER:100:0:U DS:oerror:COUNTER:100:0:U DS:collision:COUNTER:100:0:U".$macros['rra_max']);
	}
}

function delete_rrd()
{
	shell_exec("rm -rf ".DATA_DIR."*");
}

function update_rrd()
{
	global		$conf, $actions, $macros, $host;

	if ($actions['cpu'])
	{
		$nbproc = shell_exec("echo $(cat /proc/cpuinfo  | grep processor | wc -l)");

		for ($i=0; $i<$nbproc; $i++)
		{
			$file = DATA_DIR.$host."/cpu".$i.".rrd";
			
			$sp1 = shell_exec("grep \"cpu".$i."\" /proc/stat");
			sleep(1);
			$sp2 = shell_exec("grep \"cpu".$i."\" /proc/stat");

			$a_sp1 = split("[\ \t]+", $sp1);
			$a_sp2 = split("[\ \t]+", $sp2);
			$sp1_user = $a_sp1[1];
			$sp2_user = $a_sp2[1];
			$sp1_syst = $a_sp1[3];
			$sp2_syst = $a_sp2[3];
			$sp1_nice = $a_sp1[2];
			$sp2_nice = $a_sp2[2];
			$sp1_idle = $a_sp1[4];
			$sp2_idle = $a_sp2[4];

			$sp1_total = $sp1_user + $sp1_syst + $sp1_nice + $sp1_idle;
			$sp2_total = $sp2_user + $sp2_syst + $sp2_nice + $sp2_idle;

			$tps = $sp2_total - $sp1_total;

			$user = round(percent($sp1_user, $sp2_user, $tps));
			$syst = round(percent($sp1_syst, $sp2_syst, $tps));
			$nice = round(percent($sp1_nice, $sp2_nice, $tps));
			$idle = round(percent($sp1_idle, $sp2_idle, $tps));

			shell_exec("rrdtool update ".$file." N:".$user.":".$syst.":".$nice.":".$idle);
		}
	}

	if ($actions['net'])
	{
		$nbnet = shell_exec("echo $(cat /proc/net/dev | grep eth | wc -l)");
		for ($i=0; $i<$nbnet; $i++)
		{
			$type = "eth".$i;
			update_net($type, $host);
		}
		
		$nbnet = shell_exec("echo $(cat /proc/net/dev | grep ppp | wc -l)");
		for ($i=0; $i<$nbnet; $i++)
		{
			$type = "ppp".$i;
			update_net($type, $host);
		}
	}

	if ($actions['mem'])
	{
		$file = DATA_DIR.$host."/mem.rrd";

		$ram = shell_exec("grep 'Mem:' /proc/meminfo");
		$ram2 = split("[\ \t]+", $ram);
		$mtotal = $ram2[1];
		$mused = $ram2[2]-$ram2[5]-$ram2[6];

		$swap = shell_exec("grep 'Swap:' /proc/meminfo");
		$swap2 = split("[\ \t]+", $swap);
		$stotal = $swap2[1];
		$sused = $swap2[2];

		shell_exec("rrdtool update ".$file." N:".$mtotal.":".$mused.":".$stotal.":".$sused);
	}

	if ($actions['load'])
	{
		$file = DATA_DIR.$host."/load.rrd";

		$load = shell_exec("cat /proc/loadavg");
		$load2 = split("[\ \t]+", $load);
		$loadavg = $load2[0];
		
		shell_exec("rrdtool update ".$file." N:".$loadavg);
	}

	if ($actions['disk'])
	{
		$file = DATA_DIR.$host."/disk.rrd";

		$info = shell_exec("grep 'disk_io' /proc/stat");
		preg_match_all('/\(\d+,\d+\):\((\d+),\d+,\d+,\d+,\d+\)/', $info, $info2, PREG_PATTERN_ORDER);
		$disk = 0;
		for ($i=0; $i<count($info2[1]); $i++)
			$disk+= $info2[1][$i];
		
		shell_exec("rrdtool update ".$file." N:".$disk);
	}
}

function update_net($type, $host)
{
	$file = DATA_DIR.$host."/net_".$type.".rrd";

	$values = shell_exec("grep ".$type." /proc/net/dev | cut -b8-");
	$values2 = split("[\ \t]+", $values);
	$inbytes = $values2[0];
	$outbytes = $values2[8];
	$erinbytes = $values2[2]+$values2[3]+$values2[4]+$values2[5];
	$eroutbytes = $values2[10]+$values2[11]+$values2[12]+$values2[14];
	$cobytes = $values2[13];

	shell_exec("rrdtool update ".$file." N:".$inbytes.":".$outbytes.":".$erinbytes.":".$eroutbytes.":".$cobytes);
}

function store_rrd()
{
	global		$conf, $host;

	switch($conf['store_method'])
	{
	case "none":
		break;
	case "cp":
		shell_exec("cp -r ".DATA_DIR.$host." ".$conf['remote_dir']);
		break;
	}
}

?>
